WebInspector.WikiParser=function(wikiMarkupText)
{this._position=0;this._wikiMarkupText=wikiMarkupText;this._document=this._parse();this._tokenizer;}
WebInspector.WikiParser.State={Error:"Error",FirstOpen:"FirstOpen",SecondOpen:"SecondOpen",Title:"Title",PropertyName:"PropertyName",PropertyValue:"PropertyValue",FirstClose:"FirstClose",SecondClose:"SecondClose"}
WebInspector.WikiParser.LinkStates={Error:"Error",LinkUrl:"LinkUrl",LinkName:"LinkName"}
WebInspector.WikiParser.HtmlStates={Error:"Error",Entry:"Entry",InsideTag:"InsideTag",Exit:"Exit"}
WebInspector.WikiParser.ValueState={Error:"Error",Outside:"Outside",InsideSquare:"InsideSquare"}
WebInspector.WikiParser.TokenType={TripleQuotes:"TripleQuotes",OpeningBrackets:"OpeningBrackets",OpeningCodeTag:"OpeningCodeTag",ClosingBrackets:"ClosingBrackets",ClosingCodeTag:"ClosingCodeTag",Bullet:"Bullet",Text:"Text",VerticalLine:"VerticalLine",LineEnd:"LineEnd",CodeBlock:"CodeBlock"}
WebInspector.WikiParser.Token=function(result,type)
{this._value=result;this._type=type;}
WebInspector.WikiParser.Token.prototype={value:function()
{return this._value;},type:function()
{return this._type;}}
WebInspector.WikiParser.Tokenizer=function(str)
{this._text=str;}
WebInspector.WikiParser.Tokenizer.prototype={_nextToken:function()
{if(WebInspector.WikiParser.newLineWithSpace.test(this._text)){var result=WebInspector.WikiParser.newLineWithSpace.exec(this._text);var begin=result.index+result[0].length;var end=this._text.length;var lineEnd=WebInspector.WikiParser.newLineWithoutSpace.exec(this._text);if(lineEnd)
end=lineEnd.index;var token=this._text.substring(begin,end).replace(/\n */g,"\n");this._text=this._text.substring(end+1);return new WebInspector.WikiParser.Token(token,WebInspector.WikiParser.TokenType.CodeBlock);}
for(var i=0;i<WebInspector.WikiParser._tokenDescriptors.length;++i){var result=WebInspector.WikiParser._tokenDescriptors[i].regex.exec(this._text);if(result){this._text=this._text.substring(result.index+result[0].length);return new WebInspector.WikiParser.Token(result[0],WebInspector.WikiParser._tokenDescriptors[i].type);}}
for(var lastIndex=0;lastIndex<this._text.length;++lastIndex){var testString=this._text.substring(lastIndex);for(var i=0;i<WebInspector.WikiParser._tokenDescriptors.length;++i){if(WebInspector.WikiParser._tokenDescriptors[i].regex.test(testString)){var token=this._text.substring(0,lastIndex);this._text=this._text.substring(lastIndex);return new WebInspector.WikiParser.Token(token,WebInspector.WikiParser.TokenType.Text);}}}
var token=this._text;this._text="";return new WebInspector.WikiParser.Token(token,WebInspector.WikiParser.TokenType.Text);},_hasMoreTokens:function()
{return!!this._text.length;}}
WebInspector.WikiParser.prototype={document:function()
{return this._document;},_parse:function()
{var obj={};this._wikiMarkupText=this._wikiMarkupText.replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&#58;/g,":").replace(/&quot;/g,"\"").replace(/&#60;/g,"<").replace(/&#62;/g,">").replace(/{{=}}/g,"=").replace(/{{!}}/g,"|");while(this._position<this._wikiMarkupText.length){var field=this._parseField();for(var key in field){console.assert(typeof obj[key]==="undefined","Duplicate key: "+key);obj[key]=field[key];}}
return obj;},_parseValue:function(){var states=WebInspector.WikiParser.ValueState;var state=states.Outside;var value="";while(this._position<this._wikiMarkupText.length){switch(state){case states.Outside:if(this._wikiMarkupText[this._position]==="|"||(this._wikiMarkupText[this._position]==="}"&&this._wikiMarkupText[this._position+1]==="}"))
return value;switch(this._wikiMarkupText[this._position]){case"<":var indexClose=this._wikiMarkupText.indexOf(">",this._position);if(indexClose!==-1){value+=this._wikiMarkupText.substring(this._position,indexClose+1);this._position=indexClose;}
break;case"[":state=states.InsideSquare;value+=this._wikiMarkupText[this._position];break;default:value+=this._wikiMarkupText[this._position];}
break;case states.InsideSquare:if(this._wikiMarkupText[this._position]==="["){var indexClose=this._wikiMarkupText.indexOf("]]",this._position);if(indexClose!==-1){value+=this._wikiMarkupText.substring(this._position,indexClose+2);this._position=indexClose+1;}}else{var indexClose=this._wikiMarkupText.indexOf("]",this._position);if(indexClose!==-1){value+=this._wikiMarkupText.substring(this._position,indexClose+1);this._position=indexClose;}}
state=states.Outside;break;}
this._position++;}
return value;},_parseField:function()
{var obj={};var title="";var propertyName="";var propertyValue="";var states=WebInspector.WikiParser.State;var state=states.FirstOpen;while(this._position<this._wikiMarkupText.length){var skipIncrement=false;switch(state){case states.FirstOpen:if(this._wikiMarkupText[this._position]==="{")
state=states.SecondOpen;else
state=states.Error;break;case states.SecondOpen:if(this._wikiMarkupText[this._position]==="{")
state=states.Title;else
state=states.Error;break;case states.Title:if(this._wikiMarkupText[this._position]==="|"){title=this._deleteTrailingSpaces(title);if(title!=="")
obj[title]={};state=states.PropertyName;}else if(this._wikiMarkupText[this._position]==="}"){title=this._deleteTrailingSpaces(title);if(title!=="")
obj[title]={};state=states.FirstClose;}else{title+=(this._wikiMarkupText[this._position]==="\n"?"":this._wikiMarkupText[this._position]);}
break;case states.PropertyName:if(this._wikiMarkupText[this._position]==="="){state=states.PropertyValue;this._deleteTrailingSpaces(propertyName);if(propertyName!=="")
obj[title][propertyName]=[];}else{if(this._wikiMarkupText[this._position]==="}"){propertyName=this._deleteTrailingSpaces(propertyName);obj[title]=propertyName;state=states.FirstClose;}else{propertyName+=this._wikiMarkupText[this._position];}}
break;case states.PropertyValue:if(this._wikiMarkupText[this._position]==="{"&&this._wikiMarkupText[this._position+1]==="{"){propertyValue=this._parseField();obj[title][propertyName].push(propertyValue);propertyValue="";skipIncrement=true;}else if(this._wikiMarkupText[this._position]==="|"){propertyValue=this._deleteTrailingSpaces(propertyValue);if(propertyValue!=="")
obj[title][propertyName]=propertyValue;state=states.PropertyName;if(Array.isArray(obj[title][propertyName])&&obj[title][propertyName].length===1){var newObj=obj[title][propertyName][0];obj[title][propertyName]=newObj;}
propertyName="";propertyValue="";}else if(this._position+1<this._wikiMarkupText.length&&this._wikiMarkupText[this._position]==="}"&&this._wikiMarkupText[this._position+1]==="}"){propertyValue=this._deleteTrailingSpaces(propertyValue);if(propertyValue!=="")
obj[title][propertyName].push(propertyValue);if(Array.isArray(obj[title][propertyName])&&obj[title][propertyName].length===1){var newObj=obj[title][propertyName][0];obj[title][propertyName]=newObj;}
propertyValue="";state=states.FirstClose;}else{propertyValue=this._parseValue();skipIncrement=true;}
break;case states.FirstClose:if(this._wikiMarkupText[this._position]==="}")
state=states.SecondClose;else
state=states.Error;break;case states.SecondClose:while(this._position<this._wikiMarkupText.length&&this._wikiMarkupText[this._position]==="\n")
this._position++;return obj;case states.Error:this._position=this._wikiMarkupText.length;return{};}
if(!skipIncrement)
this._position++;}
return obj;},parseString:function(str)
{this._tokenizer=new WebInspector.WikiParser.Tokenizer(str);var children=[];var blockChildren=[];var text="";var self=this;function processSimpleText()
{var currentText=self._deleteTrailingSpaces(text);if(!currentText.length)
return;var simpleText=new WebInspector.WikiParser.PlainText(currentText,false);blockChildren.push(simpleText);text="";}
function processBlock()
{if(blockChildren.length){children.push(new WebInspector.WikiParser.Block(blockChildren,false));blockChildren=[];}}
while(this._tokenizer._hasMoreTokens()){var token=this._tokenizer._nextToken();switch(token.type()){case WebInspector.WikiParser.TokenType.TripleQuotes:processSimpleText();var highlightText=this._parseHighlight();blockChildren.push(highlightText)
break;case WebInspector.WikiParser.TokenType.OpeningBrackets:processSimpleText();var link=this._parseLink();blockChildren.push(link);break;case WebInspector.WikiParser.TokenType.OpeningCodeTag:processSimpleText();var code=this._parseCode();blockChildren.push(code);break;case WebInspector.WikiParser.TokenType.Bullet:processSimpleText();processBlock();var bulletText=this._parseBullet();children.push(bulletText);break;case WebInspector.WikiParser.TokenType.CodeBlock:processSimpleText();processBlock();var code=new WebInspector.WikiParser.CodeBlock(token.value());children.push(code);break;case WebInspector.WikiParser.TokenType.LineEnd:processSimpleText();processBlock();break;case WebInspector.WikiParser.TokenType.VerticalLine:case WebInspector.WikiParser.TokenType.Text:text+=token.value();break;default:return null;}}
processSimpleText();processBlock();return new WebInspector.WikiParser.Block(children,false);},_parseLink:function()
{var url="";var children=[];while(this._tokenizer._hasMoreTokens()){var token=this._tokenizer._nextToken();switch(token.type()){case WebInspector.WikiParser.TokenType.ClosingBrackets:return new WebInspector.WikiParser.Link(url,children);case WebInspector.WikiParser.TokenType.VerticalLine:children.push(this._parseLinkName());return new WebInspector.WikiParser.Link(url,children);default:url+=token.value();}}
return new WebInspector.WikiParser.Link(url,children);},_parseLinkName:function()
{var children=[];while(this._tokenizer._hasMoreTokens()){var token=this._tokenizer._nextToken();switch(token.type()){case WebInspector.WikiParser.TokenType.ClosingBrackets:return new WebInspector.WikiParser.Inline(WebInspector.WikiParser.ArticleElement.Type.Inline,children);case WebInspector.WikiParser.TokenType.OpeningCodeTag:children.push(this._parseCode());break;default:children.push(new WebInspector.WikiParser.PlainText(token.value(),false));break;}}
return new WebInspector.WikiParser.Inline(WebInspector.WikiParser.ArticleElement.Type.Inline,children);},_parseCode:function()
{var children=[];var text="";while(this._tokenizer._hasMoreTokens()){var token=this._tokenizer._nextToken();switch(token.type()){case WebInspector.WikiParser.TokenType.ClosingCodeTag:text=this._deleteTrailingSpaces(text);if(text.length){var simpleText=new WebInspector.WikiParser.PlainText(text,false);children.push(simpleText);text="";}
var code=new WebInspector.WikiParser.Inline(WebInspector.WikiParser.ArticleElement.Type.Code,children);return code;case WebInspector.WikiParser.TokenType.OpeningBrackets:var link=this._parseLink();children.push(link);break;default:text+=token.value();}}
text=this._deleteTrailingSpaces(text);if(text.length)
children.push(new WebInspector.WikiParser.PlainText(text,false));return new WebInspector.WikiParser.Inline(WebInspector.WikiParser.ArticleElement.Type.Code,children);},_parseBullet:function()
{var children=[];while(this._tokenizer._hasMoreTokens()){var token=this._tokenizer._nextToken()
switch(token.type()){case WebInspector.WikiParser.TokenType.OpeningBrackets:children.push(this._parseLink());break;case WebInspector.WikiParser.TokenType.OpeningCodeTag:children.push(this._parseCode());break;case WebInspector.WikiParser.TokenType.LineEnd:return new WebInspector.WikiParser.Block(children,true);default:var text=this._deleteTrailingSpaces(token.value());if(text.length){var simpleText=new WebInspector.WikiParser.PlainText(text,false);children.push(simpleText);text="";}}}
return new WebInspector.WikiParser.Block(children,true);},_parseHighlight:function()
{var text="";while(this._tokenizer._hasMoreTokens()){var token=this._tokenizer._nextToken()
switch(token.type()){case WebInspector.WikiParser.TokenType.TripleQuotes:text=this._deleteTrailingSpaces(text);return new WebInspector.WikiParser.PlainText(text,true);default:text+=token.value();}}
return new WebInspector.WikiParser.PlainText(text,true);},_deleteTrailingSpaces:function(str)
{return str.replace(/[\n\r]*$/gm,"");}}
WebInspector.WikiParser.oneOpeningBracket=/^\n*\[[^\[]/;WebInspector.WikiParser.twoOpeningBrackets=/^\n*\[\[/;WebInspector.WikiParser.oneClosingBracket=/^\n*\][^\]]/;WebInspector.WikiParser.twoClosingBrackets=/^\n*\]\]/;WebInspector.WikiParser.tripleQuotes=/^\n*'''/;WebInspector.WikiParser.openingCodeTag=/^<\s*code\s*>/;WebInspector.WikiParser.closingCodeTag=/^<\s*\/\s*code\s*>/;WebInspector.WikiParser.closingBullet=/^\*/;WebInspector.WikiParser.lineEnd=/^\n/;WebInspector.WikiParser.verticalLine=/^\|/;WebInspector.WikiParser.newLineWithSpace=/^\n /;WebInspector.WikiParser.newLineWithoutSpace=/\n[^ ]/;WebInspector.WikiParser.TokenDesciptor=function(regex,type)
{this.regex=regex;this.type=type;}
WebInspector.WikiParser._tokenDescriptors=[new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.newLineWithSpace,WebInspector.WikiParser.TokenType.CodeBlock),new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.tripleQuotes,WebInspector.WikiParser.TokenType.TripleQuotes),new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.oneOpeningBracket,WebInspector.WikiParser.TokenType.OpeningBrackets),new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.twoOpeningBrackets,WebInspector.WikiParser.TokenType.OpeningBrackets),new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.oneClosingBracket,WebInspector.WikiParser.TokenType.ClosingBrackets),new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.twoClosingBrackets,WebInspector.WikiParser.TokenType.ClosingBrackets),new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.openingCodeTag,WebInspector.WikiParser.TokenType.OpeningCodeTag),new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.closingCodeTag,WebInspector.WikiParser.TokenType.ClosingCodeTag),new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.closingBullet,WebInspector.WikiParser.TokenType.Bullet),new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.verticalLine,WebInspector.WikiParser.TokenType.VerticalLine),new WebInspector.WikiParser.TokenDesciptor(WebInspector.WikiParser.lineEnd,WebInspector.WikiParser.TokenType.LineEnd)];WebInspector.WikiParser.ArticleElement=function(type)
{this._type=type;}
WebInspector.WikiParser.ArticleElement.prototype={type:function()
{return this._type;}}
WebInspector.WikiParser.ArticleElement.Type={PlainText:"PlainText",Link:"Link",Code:"Code",Block:"Block",CodeBlock:"CodeBlock",Inline:"Inline"};WebInspector.WikiParser.PlainText=function(text,highlight)
{WebInspector.WikiParser.ArticleElement.call(this,WebInspector.WikiParser.ArticleElement.Type.PlainText);this._text=text;this._isHighlighted=highlight;}
WebInspector.WikiParser.PlainText.prototype={text:function()
{return this._text;},isHighlighted:function()
{return this._isHighlighted;},__proto__:WebInspector.WikiParser.ArticleElement.prototype}
WebInspector.WikiParser.Block=function(children,hasBullet)
{WebInspector.WikiParser.ArticleElement.call(this,WebInspector.WikiParser.ArticleElement.Type.Block);this._children=children;this._hasBullet=hasBullet}
WebInspector.WikiParser.Block.prototype={children:function()
{return this._children;},hasBullet:function()
{return this._hasBullet;},__proto__:WebInspector.WikiParser.ArticleElement.prototype}
WebInspector.WikiParser.CodeBlock=function(text)
{WebInspector.WikiParser.ArticleElement.call(this,WebInspector.WikiParser.ArticleElement.Type.CodeBlock);this._code=text;}
WebInspector.WikiParser.CodeBlock.prototype={code:function()
{return this._code;},__proto__:WebInspector.WikiParser.ArticleElement.prototype}
WebInspector.WikiParser.Inline=function(type,children)
{WebInspector.WikiParser.ArticleElement.call(this,type)
this._children=children;}
WebInspector.WikiParser.Inline.prototype={children:function()
{return this._children;},__proto__:WebInspector.WikiParser.ArticleElement.prototype}
WebInspector.WikiParser.Link=function(url,children)
{WebInspector.WikiParser.Inline.call(this,WebInspector.WikiParser.ArticleElement.Type.Link,children);this._url=url;}
WebInspector.WikiParser.Link.prototype={url:function()
{return this._url;},__proto__:WebInspector.WikiParser.Inline.prototype};WebInspector.JSArticle=function()
{this.pageTitle;this.standardizationStatus;this.summary;this.parameters=[];this.methods;this.remarks;this.examples=[];}
WebInspector.JSArticle.Parameter=function(name,dataType,optional,description)
{this.name=name;this.dataType=dataType;this.optional=optional;this.description=description;}
WebInspector.JSArticle.Example=function(language,code,liveUrl,description)
{this.language=language;this.code=code;this.liveUrl=liveUrl;this.description=description;}
WebInspector.JSArticle.Method=function(dataType,returnValue)
{this.dataType=dataType;this.returnValue=returnValue;}
WebInspector.JSArticle.parse=function(wikiMarkupText)
{function parseString(string,debugInfo)
{var result=wikiParser.parseString(string);if(!result)
console.error("Can't parse "+debugInfo);return result;}
var wikiParser=new WebInspector.WikiParser(wikiMarkupText);var wikiDocument=wikiParser.document();var article=new WebInspector.JSArticle();article.pageTitle=wikiDocument["Page_Title"];if(typeof article.pageTitle!=="string")
delete article.pageTitle;article.standardizationStatus=wikiDocument["Standardization_Status"];if(article.standardizationStatus!=="string")
delete article.standardizationStatus;var apiObjectMethod=wikiDocument["API_Object_Method"];if(apiObjectMethod){var dataType=apiObjectMethod["Javascript_data_type"];var returnValue=apiObjectMethod["Return_value_name"];if(dataType&&returnValue)
article.methods=new WebInspector.JSArticle.Method(dataType,returnValue);}
var remarks=wikiDocument["Remarks_Section"]?wikiDocument["Remarks_Section"]["Remarks"]:null;if(remarks)
article.remarks=parseString(remarks,"remarks");var summary=wikiDocument["Summary_Section"];if(summary)
article.summary=parseString(summary,"summary");var examples=wikiDocument["Examples_Section"]?wikiDocument["Examples_Section"]["Examples"]:[];if(!Array.isArray(examples)&&typeof examples!=="undefined")
examples=[examples];for(var i=0;i<examples.length;++i){var language=examples[i]["Single Example"]["Language"];var code=examples[i]["Single Example"]["Code"];var liveUrl=examples[i]["Single Example"]["LiveURL"];var description=parseString(examples[i]["Single Example"]["Description"],"example description");article.examples.push(new WebInspector.JSArticle.Example(language,code,liveUrl,description));}
var parameters=apiObjectMethod?apiObjectMethod["Parameters"]:[];if(!Array.isArray(parameters)&&typeof parameters!=="undefined")
parameters=[parameters];for(var i=0;i<parameters.length;++i){var name=parameters[i]["Method Parameter"]["Name"];var dataType=parameters[i]["Method Parameter"]["Data type"];var optional=parameters[i]["Method Parameter"]["Optional"];var description=parseString(parameters[i]["Method Parameter"]["Description"],"method description");article.parameters.push(new WebInspector.JSArticle.Parameter(name,dataType,optional,description));}
return article;};WebInspector.DocumentationURLProvider=function()
{this._gapFromIndex=0;this._gapFrom=WebInspector.DocumentationURLProvider._gapFromList[0];this._state=WebInspector.DocumentationURLProvider.DownloadStates.NotStarted;this._articleList=new StringMap();}
WebInspector.DocumentationURLProvider.DownloadStates={NotStarted:"NotStarted",InProgress:"InProgress",Finished:"Finished",Failed:"Failed"}
WebInspector.DocumentationURLProvider.instance=function()
{if(!WebInspector.DocumentationURLProvider._instance)
WebInspector.DocumentationURLProvider._instance=new WebInspector.DocumentationURLProvider();return WebInspector.DocumentationURLProvider._instance;}
WebInspector.DocumentationURLProvider.ItemDescriptor=function(sourceRef,searchTerm)
{this._url=String.sprintf(WebInspector.DocumentationURLProvider._articleUrlFormat,sourceRef.url(),searchTerm);this._name=sourceRef.name();this._searchItem=searchTerm;}
WebInspector.DocumentationURLProvider.ItemDescriptor.prototype={url:function()
{return this._url;},name:function()
{return this._name;},searchItem:function()
{return this._searchItem;}}
WebInspector.DocumentationURLProvider.DocumentationSource=function(source,url,name)
{this._source=source;this._url=url;this._name=name;}
WebInspector.DocumentationURLProvider.DocumentationSource.prototype={source:function()
{return this._source;},url:function()
{return this._url;},name:function()
{return this._name;}}
WebInspector.DocumentationURLProvider._sources=[new WebInspector.DocumentationURLProvider.DocumentationSource(window,"javascript/","Global"),new WebInspector.DocumentationURLProvider.DocumentationSource(Node.prototype,"dom/Node/","Node.prototype"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Node,"dom/Node/","Node"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Object.prototype,"javascript/Object/","Object.prototype"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Object,"javascript/Object/","Object"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Math,"javascript/Math/","Math"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Array.prototype,"javascript/Array/","Array.prototype"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Array,"javascript/Array/","Array"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.String.prototype,"javascript/String/","String.prototype"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.String,"javascript/String/","String"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Date.prototype,"javascript/Date/","Date.prototype"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Date,"javascript/Date/","Date"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.JSON,"javascript/JSON/","JSON"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Number,"javascript/Number/","Number"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Number.prototype,"javascript/Number/","Number.prototype"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Error.prototype,"javascript/Error/","Error.prototype"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.RegExp.prototype,"javascript/RegExp/","RegExp.prototype"),new WebInspector.DocumentationURLProvider.DocumentationSource(window.Function.prototype,"javascript/Function/","Function.prototype")];WebInspector.DocumentationURLProvider._articleUrlFormat="http://docs.webplatform.org/w/api.php?action=query&titles=%s%s&prop=revisions&rvprop=timestamp|content&format=json";WebInspector.DocumentationURLProvider._articleListUrlFormat="http://docs.webplatform.org/w/api.php?action=query&generator=allpages&gaplimit=500&gapfrom=%s&format=json";WebInspector.DocumentationURLProvider._gapFromList=["dom/Node/","javascript/"];WebInspector.DocumentationURLProvider.prototype={itemDescriptors:function(searchTerm)
{if(this._state===WebInspector.DocumentationURLProvider.DownloadStates.Finished)
return this._articleList.get(searchTerm)||[];if(this._state===WebInspector.DocumentationURLProvider.DownloadStates.NotStarted)
this._loadArticleList();var descriptors=[];var sources=WebInspector.DocumentationURLProvider._sources;var propertyName=searchTerm.toUpperCase()===searchTerm?"constants":searchTerm;for(var i=0;i<sources.length;++i){if(!sources[i].source().hasOwnProperty(propertyName))
continue;descriptors.push(new WebInspector.DocumentationURLProvider.ItemDescriptor(sources[i],propertyName));}
return descriptors;},_loadArticleList:function()
{this._state=WebInspector.DocumentationURLProvider.DownloadStates.InProgress;var gapFromList=WebInspector.DocumentationURLProvider._gapFromList;if(this._gapFromIndex>=gapFromList.length)
return;if(!this._gapFrom.startsWith(gapFromList[this._gapFromIndex])){++this._gapFromIndex;if(this._gapFromIndex===gapFromList.length){this._state=WebInspector.DocumentationURLProvider.DownloadStates.Finished;return;}
this._gapFrom=gapFromList[this._gapFromIndex];}
var url=String.sprintf(WebInspector.DocumentationURLProvider._articleListUrlFormat,this._gapFrom);loadXHR(url).then(processData.bind(this),resetDownload.bind(this));function processData(responseText)
{if(!responseText){resetDownload.call(this);return;}
var json=JSON.parse(responseText);this._gapFrom=json["query-continue"]["allpages"]["gapcontinue"];var pages=json["query"]["pages"];for(var article in pages)
this._addDescriptorToList(pages[article]["title"]);this._loadArticleList();}
function resetDownload()
{WebInspector.console.error("Documentation article list download failed");this._state=WebInspector.DocumentationURLProvider.DownloadStates.Failed;}},_addDescriptorToList:function(itemPath)
{var lastSlashIndex=itemPath.lastIndexOf("/");if(lastSlashIndex===-1)
return;var sourceName=itemPath.substring(0,lastSlashIndex+1);var propertyName=itemPath.substring(lastSlashIndex+1).replace(" ","_");var sources=WebInspector.DocumentationURLProvider._sources;for(var i=0;i<sources.length;++i){if(sources[i].url()!==sourceName||!sources[i].source().hasOwnProperty(propertyName))
continue;var descriptors=this._articleList.get(propertyName)||[];descriptors.push(new WebInspector.DocumentationURLProvider.ItemDescriptor(sources[i],propertyName));this._articleList.set(propertyName,descriptors);}}};WebInspector.DocumentationView=function()
{WebInspector.VBox.call(this);}
WebInspector.DocumentationView.showDocumentationURL=function(url,error)
{if(!WebInspector.DocumentationView._view)
WebInspector.DocumentationView._view=new WebInspector.DocumentationView();var view=WebInspector.DocumentationView._view;WebInspector.inspectorView.showCloseableViewInDrawer("documentation",WebInspector.UIString("Documentation"),view);}
WebInspector.DocumentationView.prototype={__proto__:WebInspector.VBox.prototype}
WebInspector.DocumentationView.ContextMenuProvider=function()
{}
WebInspector.DocumentationView.ContextMenuProvider.prototype={appendApplicableItems:function(event,contextMenu,target)
{if(!(target instanceof WebInspector.CodeMirrorTextEditor))
return;var textEditor=(target);var descriptors=this._determineDescriptors(textEditor);if(!descriptors.length)
return;if(descriptors.length===1){var formatString=WebInspector.useLowerCaseMenuTitles()?"Show documentation for %s.%s":"Show Documentation for %s.%s";contextMenu.appendItem(WebInspector.UIString(formatString,descriptors[0].name(),descriptors[0].searchItem()),WebInspector.DocumentationView.showDocumentationURL.bind(null,descriptors[0].url()));return;}
var subMenuItem=contextMenu.appendSubMenuItem(WebInspector.UIString(WebInspector.useLowerCaseMenuTitles()?"Show documentation for...":"Show Documentation for..."));for(var i=0;i<descriptors.length;++i)
subMenuItem.appendItem(String.sprintf("%s.%s",descriptors[i].name(),descriptors[i].searchItem()),WebInspector.DocumentationView.showDocumentationURL.bind(null,descriptors[i].url()));},_determineDescriptors:function(textEditor)
{var urlProvider=WebInspector.DocumentationURLProvider.instance();var textSelection=textEditor.selection().normalize();if(!textSelection.isEmpty()){if(textSelection.startLine!==textSelection.endLine)
return[];return urlProvider.itemDescriptors(textEditor.copyRange(textSelection));}
var descriptors=computeDescriptors(textSelection.startColumn);if(descriptors.length)
return descriptors;return computeDescriptors(textSelection.startColumn-1);function computeDescriptors(column)
{var token=textEditor.tokenAtTextPosition(textSelection.startLine,column);if(!token)
return[];var tokenText=textEditor.line(textSelection.startLine).substring(token.startColumn,token.endColumn);return urlProvider.itemDescriptors(tokenText);}}};